/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#include <stdio.h>
#include <sys/stat.h>
#include <sys/file.h>
#include "defines.h"
#include "client_msgs.h"
#include "log.h"
#include "badref.h"

static char badref_log[MAX_LINE];

/**************************************************************************
  records the bad referrral
**************************************************************************/
int record_badref(str)
char *str;

{
if (strlen (str) == NULL)
  print_error (INVALID_DIRECTIVE_PARAM, "");
else if (log_entry (badref_log, "Bad Ref: %s", str))
  print_ok();
set_passthru();
return(0);
}

/**************************************************************************
  sets the badref filename
**************************************************************************/
int set_badref_log (str)
char *str;

{
strcpy (badref_log, str);
}

#if NOK
/**************************************************************************
  records the badref info
  returns TRUE if can
          FALSE if not
**************************************************************************/
int save_into_log (filename, format, str)
char *filename;
char *format;
char *str;

{
FILE *fp;
int fd, retval = TRUE;

if ((fp = fopen (filename, "a")) == NULL) {
  log ("ERROR save_into_log: could not open file %s", filename);
  print_error (UNIDENT_ERROR,"");
  return (FALSE);
  }
fd = fileno (fp);

/** lock for exclusive use  - default is to wait **/
if (flock (fd, LOCK_EX) != 0) {
  log ("ERROR save_into_log: could not start lock for %s", filename);
  retval = FALSE;
  }

if (retval) {
  timestamp(fp);
  fprintf (fp, " [%-15s] ", get_hostname(1));
  fprintf (fp, format, str);
  /** unlock file **/
  if (flock (fd, LOCK_UN) != 0) {
    log ("ERROR save_into_log: could not release lock for %s", filename);
    retval = FALSE;
    }
  }
fclose (fp);
return (retval);
}
#endif
