/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#ifndef _COMMANDS_H_
#define _COMMANDS_H_
#include "objects.h"

typedef enum {
  COMMAND_DISPLAY,                 /* command is a display command */
  COMMAND_OBJECT,                  /* command is a object command */
  COMMAND_QUERY,                   /* command is a query command */
  COMMAND_DIRECTIVE,               /* command is a server directive */
  COMMAND_X_DIRECTIVE,             /* command is a extended server directive */
  COMMAND_SPECIAL,                 /* command is a "special" command (help) */
  COMMAND_NUM                      /* don't delete */
  } command_type;
  
typedef struct _command_struct  {
   char *command;                  /* command to initiate this action */
   int   len;                      /* min length to activate the command */
   char *magic;                    /* one char magic command */
   char *description;              /* description of command */
   int   arg_required;             /* argument required */
   command_type type;              /* type of command */
   object_struct  *object;         /* pointer to object */
   char *program;                  /* program to execute */
   int (*function)();              /* run function */
   char *syntax;                   /* syntax of the command */
   struct _command_struct *nxt;
} command_struct;

#define NEW_COMMAND (command_struct *) calloc ((unsigned)1, \
   (unsigned)sizeof(command_struct))

object_struct *return_object_by_command();
int display_directive();
command_struct *return_commands_by_object();

#endif
