#if sun
#include <sys/fcntlcom.h>
#include <sys/ttycom.h>
#include <sys/ioctl.h>
#endif
#include <signal.h>
#include <sys/types.h>
#include <sys/syslog.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include "client_msgs.h"


run_daemon(root_server, hostname, port)
  int  root_server;
  char *hostname;
  int  port;

{
  struct sockaddr_in client_addr;
  struct sockaddr_in server_addr;
  struct hostent *hp;
  int sockfd;
  int newsockfd;
  int clilen;
  int childpid;
  int status;
  int newpid;

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    print_error (MISC_DIAG, "run_daemon: Can not open socket");
    exit (1);
  }

  hp = gethostbyname(hostname);
  if (hp == NULL) {
    print_error (MISC_DIAG, "run_daemon: unknown host '%s'", hostname);
    exit(1);
  }

  /* Bind our local address so that the client can send to us */
  bzero ((char *)&server_addr, sizeof(server_addr));
  server_addr.sin_family = AF_INET;
  server_addr.sin_port = htons(port);      /* Restricted port */
  server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  /* bcopy (hp->h_addr, (char *)&server_addr.sin_addr, hp->h_length); */
  setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, 0, 0);
  if (bind(sockfd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
    print_error (MISC_DIAG, "run_daemon: Can not bind socket");
    exit(1);
  }

  listen(sockfd, 5);
  for (;;) {
    clilen = sizeof(client_addr);
    newsockfd = accept (sockfd, (struct sockaddr *) &client_addr, &clilen);
    if (newsockfd < 0) {
      print_error (MISC_DIAG, "run_daemon: accept error");
      exit (1);
    }
    if ((childpid = fork()) <  0) {
      print_error (MISC_DIAG, "run_daemon: fork error");
      exit (1);
    }

    else if (childpid  ==  0) {
      signal(SIGCHLD,SIG_IGN);
      if ((newpid = fork()) < 0) {
        print_error (MISC_DIAG, "run_daemon: fork error");
        exit(1);
      }
      if (newpid == 0) {
        if (dup2 (newsockfd, 0) == -1) {
          print_error (MISC_DIAG, "run_daemon: dup error");
          exit (1);
        }
        if (dup2 (newsockfd, 1) == -1) {
          print_error (MISC_DIAG, "run_daemon: dup error");
          exit (1);
        }
        close (sockfd);
        run_session (root_server);
        exit (0);
      }
      else {
        close(sockfd);
        close (newsockfd);
        exit(0);
      }
    }
    close (newsockfd);
    wait(&status);
  }
}
