/************************************************************************
RWhois Software

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and
that no charge is made for such copies.

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By:
  Mark Kosters
***************************************************************************/
#include <signal.h>
#include "deadman.h"
#include "conf.h"
#include "client_msgs.h"

#define POLL_TIME 5
static int deadman_time = POLL_TIME;

/******************************************************************************
  sets the timer for seconds before calling function
******************************************************************************/
int set_timer(seconds, function)
int seconds;
void *function;
{
  if(seconds)
  {
    signal(SIGALRM, function);
    alarm(seconds);
  }
  return;
}

/******************************************************************************
 notifies user that deadman time has come - logs it and bye!
******************************************************************************/
int is_a_deadman()
{
print_error (DEADMAN_TIME, "");
log_entry (RWHOIS_LOG_FILE, "Deadman time - exiting");
exit();
}

/******************************************************************************
 unsets the timer
******************************************************************************/
int unset_timer ()
{
signal(SIGALRM, SIG_IGN);
}

/******************************************************************************
 sets seconds before exiting (read from config file)
******************************************************************************/
set_deadman_time (secs)
char *secs;

{
if (atoi (secs))
  deadman_time = atoi(secs);
}

/******************************************************************************
 recovers the deadman second timer
******************************************************************************/
get_deadman_time ()
{
return (deadman_time);
}
