#include <time.h>
#include "fileutils.h"

/*****************************************************************************
  Function: Returns current date/time in yymmddhhmmss string
  By: Mark Kosters
*****************************************************************************/
char *make_timestamp ()

{
static char buffer[15];
struct tm *tm, *localtime();
time_t t;

time (&t);
tm = localtime( &t );
strftime (buffer, 14, "%y%m%d%H%M%S", tm);
return (buffer);
}

/*****************************************************************************
  Function: Returns a temp filename (that is also the ticket #
  By: Mark Kosters
*****************************************************************************/
char *create_filename (fname, template, spool_directory)
char *fname;
char *template;
char *spool_directory;

{
sprintf (fname, template, spool_directory, make_timestamp());
mktemp (fname);
return (fname);
}

/*****************************************************************************
  Function: Returns a data text filename (that is also the ticket #
  By: Mark Kosters
*****************************************************************************/
char *create_db_filename (fname, template, spool_directory, postfix)
char *fname;
char *template;
char *spool_directory;
char *postfix;

{
sprintf (fname, template, spool_directory, make_timestamp(), postfix);
mktemp (fname);
return (fname);
}
