/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "types.h"
#include "help.h"

/****************************************************************************
 checks if is a non-query
   returns TRUE if so
           FALSE otherwise
*****************************************************************************/
int non_query_flag_set (flag)
unsigned int flag;

{
if (ON(flag, EXIT_QUERY) || ON (flag, HELP_QUERY))
  return (TRUE);
return (FALSE);
}

/****************************************************************************
 checks if is a exit or help query
   returns either help result or exit result
*****************************************************************************/
int exit_or_help(flag)
unsigned int flag;

{
if (ON(flag, EXIT_QUERY))
  return (FALSE);
return (help());
}

/****************************************************************************
 help file
*****************************************************************************/
int help()
{
set_passthru();
if (!type_file(DEFAULT_RWHOIS_HELP_FILE))
  {
  /* printf("Sorry, can't find help file %s\n", WHOIS_HELP_FILE); */
  printf("Sorry, no help file has been installed at this site.\n");
  return FALSE;
  }
return FALSE;
}

/****************************************************************************
 types out file
*****************************************************************************/
int type_file(file)
char *file;
{
FILE *f;
char line[MAX_LINE];
int c, line_count;

if (!(f = fopen(file, "r")))        /* open file to be typed */
  return FALSE;             /* oops, can't... */
while ((c = getc(f)) != EOF)
  putchar(c);
fclose (f);
print_ok();
return TRUE;
}
