/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "limit.h"
#include "client_msgs.h"

static int max_hits = DEFAULT_MAX_HITS;
static int max_hit_ceiling = CEILING_MAX_HITS;

/*************************************************************************
 sets the maximum hits for a particular query
**************************************************************************/
set_max_hit_limit(str)
char *str;

{
int hits;

if ( !strlen (str) || (hits = atoi (str)) < 1)
  print_error (INVALID_MAXREC, "");
else if (hits > max_hit_ceiling)
  print_error (EXCEEDED_MAXREC, "");
else {
  print_ok();
  max_hits = hits;
  }
set_passthru();
}

/*************************************************************************
  retrieves the maximum hits for wais
**************************************************************************/
get_max_hit_limit()
{
return (max_hits);
}

/*************************************************************************
  sets the max hit default from initialization
**************************************************************************/
set_max_hits_default (limit)
int limit;

{
max_hits = limit;
}

/*************************************************************************
  sets the max hit ceiling from initialization
**************************************************************************/
set_max_hits_ceiling (limit)
int limit;

{
max_hit_ceiling = limit;
}
