/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#include "client_msgs.h"
#include "load.h"

#include <stdio.h>
#if !SOLARIS 
#include <sys/param.h>
#if sun
#include <sys/fcntlcom.h>
#endif
#endif

#define MAXLOAD 10

#if SOLARIS
#define LOADSYMBOL "avenrun"    /* should work with most Unix flavors */
#else
#define LOADSYMBOL "_avenrun"    /* should work with most Unix flavors */
#endif


#define WHICHLOAD  2             /* 0 ==  1 min average           */
                                 /* 1 ==  5 min average           */
                                 /* 2 == 15 min average           */

double atof();
double maxload = MAXLOAD;
#include <nlist.h>
#include <kvm.h>
#include <fcntl.h>
#define X_AVENRUN 0

/**************************************************************************
  shows the system load
**************************************************************************/
int display_system_load(str)
char *str;

{
double avgload = 0.0;
double sysload = 0.0;

sysload = read_system_load(0);
avgload = read_system_load(2);
if (sysload == -1 || avgload == -1)
  print_error (UNAVAIL_SYSLOAD, "");
else {
  printf("%%load %5.2f %5.2f\n", sysload, avgload);
  print_ok();
  }
set_passthru();
return(0);
}

/**************************************************************************
  reads the kernel memory
**************************************************************************/
double read_system_load (whichload)
int whichload;

{
long avenrun[3];
kvm_t * kd;
static struct nlist nl[] = { {LOADSYMBOL}, {""}, };

if ((kd = kvm_open(NULL, NULL, NULL, O_RDONLY, NULL)) == NULL) 
  return(-1);
if (kvm_nlist(kd, nl) != 0) 
  return(-1);
if(nl[X_AVENRUN].n_type == 0) 
  return(-1);
if(kvm_read(kd,nl[X_AVENRUN].n_value,avenrun,sizeof(avenrun))
  != sizeof(avenrun)) 
  return(-1);
return (((double) avenrun[whichload]) / FSCALE);
}

