/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include "objects.h"

#ifndef _PARSE_H_
#define _PARSE_H_

/****
  logical separator types
*****/

typedef enum {
    LOGICAL_NULL,           /* null value - just in case */
    LOGICAL_AND,            /* an and boolean separator */
    LOGICAL_OR,             /* an or boolean separator */
    LOGICAL_NUM             /* total number of logicals (don't delete) */
} logical_separator_type;

/*****
  query structure
*****/

typedef struct _query_item_struct{
  char	 *value;                            /* value to query for */
  char   *attribute;                        /* attribute associated w/value */
  int    attribute_no;                      /* attribute number assoc w/index */
  char	 *display;                          /* display mode desired */
  object_struct	 *object;                   /* pointer to object desired */
  char	 *directive;                        /* server directive */
  int    (*function)();                     /* function to be performed */
  int    loop_detect;                       /* pass loop detection */
  char   *program;                          /* extended directive program */
  logical_separator_type separator;         /* type of boolean separator */
  struct _query_item_struct *nxt;
} query_item_struct;

#define NEW_QUERY_ITEM (query_item_struct *) calloc ((unsigned)1, \
   (unsigned)sizeof(query_item_struct))

/***********
  prototypes
***********/
query_item_struct *append_query();
query_item_struct *encode_command();
char *decode_command_list();
char *decode_data_for_authority_element();
char *get_display_mode();
#endif
