/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "misc.h"
#include "displays.h"
#include "status.h"
#include "client_msgs.h"
#include "load.h"
#include "llist.h"
#include "objects.h"
#include "fileinfo.h"

/**********
  local prototypes
**********/
static int get_rec_num_from_objects ();

/****************************************************************************
  shows the status of variables
****************************************************************************/
show_status (str)
char *str;

{
printf ("%%status limit: %d\n", get_max_hit_limit());
printf ("%%status load: %5.2f\n", read_system_load(0));
printf ("%%status cache: %s\n", on_off(cache_status()));
printf ("%%status holdconnect: %s\n", on_off(holdconnect_status()));
printf ("%%status forward: %s\n", on_off(forward_status()));
printf ("%%status display-single: %s\n", get_display_status("single"));
printf ("%%status display-multi: %s\n", get_display_status("multi"));
printf ("%%status authority: %d\n", get_rec_num_from_objects (0));
printf ("%%status cached: %d\n", get_rec_num_from_objects (1));
print_ok();
set_passthru();
return(0);
}

/****************************************************************************
  return number of records
****************************************************************************/
static int get_rec_num_from_objects (cached)
int cached;

{
llist_struct *list_of_objects;
object_struct *object;
char *db_fname;
char filename[MAX_LINE];

int num_recs = 0;

list_of_objects = return_objects_by_type (ALL_OBJECTS);
while (list_of_objects != NULL) {
  object = list_of_objects->datum;
  if (cached)
    db_fname = object->cache_db;
  else
    db_fname = object->local_db;
  sprintf (filename, "%s.db",db_fname);
  read_fileinfo (filename);
  num_recs += get_fileinfo_record_count();
  clear_fileinfo();
  list_of_objects = list_of_objects->nxt;
  }
return (num_recs);
}
